Index: trunk/client/modules/Elezioni/grafici/jpgraph.php
===================================================================
--- trunk/client/modules/Elezioni/grafici/jpgraph.php	(revision 264)
+++ trunk/client/modules/Elezioni/grafici/jpgraph.php	(revision 265)
@@ -1030,1192 +1170,1291 @@
     function SetYScale($aN,$aAxisType="lin",$aYMin=1,$aYMax=1) {
 
-	if( $aAxisType=="lin" ) 
-	    $this->ynscale[$aN] = new LinearScale($aYMin,$aYMax);
-	elseif( $aAxisType == "int" ) {
-	    $this->ynscale[$aN] = new LinearScale($aYMin,$aYMax);
-	    $this->ynscale[$aN]->SetIntScale();
-	}
-	elseif( $aAxisType=="log" ) {
-	    $this->ynscale[$aN] = new LogScale($aYMin,$aYMax);
-	}
-	else JpGraphError::RaiseL(25024,$aAxisType);//("JpGraph: Unsupported Y axis type: $aAxisType\nMust be one of (lin,log,int)");
-			
-	$this->ynaxis[$aN] = new Axis($this->img,$this->ynscale[$aN]);
-	$this->ynaxis[$aN]->scale->ticks->SetDirection(SIDE_LEFT); 
-	$this->ynaxis[$aN]->SetLabelSide(SIDE_RIGHT); 
+        if( $aAxisType == 'lin' ) {
+            $this->ynscale[$aN] = new LinearScale($aYMin,$aYMax);
+        }
+        elseif( $aAxisType == 'int' ) {
+            $this->ynscale[$aN] = new LinearScale($aYMin,$aYMax);
+            $this->ynscale[$aN]->SetIntScale();
+        }
+        elseif( $aAxisType == 'log' ) {
+            $this->ynscale[$aN] = new LogScale($aYMin,$aYMax);
+        }
+        else {
+            JpGraphError::RaiseL(25024,$aAxisType);//("JpGraph: Unsupported Y axis type: $aAxisType\nMust be one of (lin,log,int)");
+        }
+
+        $this->ynaxis[$aN] = new Axis($this->img,$this->ynscale[$aN]);
+        $this->ynaxis[$aN]->scale->ticks->SetDirection(SIDE_LEFT);
+        $this->ynaxis[$aN]->SetLabelSide(SIDE_RIGHT);
+
+        if ($this->graph_theme) {
+            $this->graph_theme->ApplyGraph($this);
+        }
     }
 
     // Specify density of ticks when autoscaling 'normal', 'dense', 'sparse', 'verysparse'
-    // The dividing factor have been determined heuristically according to my aesthetic 
+    // The dividing factor have been determined heuristically according to my aesthetic
     // sense (or lack off) y.m.m.v !
     function SetTickDensity($aYDensity=TICKD_NORMAL,$aXDensity=TICKD_NORMAL) {
-	$this->xtick_factor=30;
-	$this->ytick_factor=25;		
-	switch( $aYDensity ) {
-	    case TICKD_DENSE:
-		$this->ytick_factor=12;			
-		break;
-	    case TICKD_NORMAL:
-		$this->ytick_factor=25;			
-		break;
-	    case TICKD_SPARSE:
-		$this->ytick_factor=40;			
-		break;
-	    case TICKD_VERYSPARSE:
-		$this->ytick_factor=100;			
-		break;		
-	    default:
-		JpGraphError::RaiseL(25025,$densy);//("JpGraph: Unsupported Tick density: $densy");
-	}
-	switch( $aXDensity ) {
-	    case TICKD_DENSE:
-		$this->xtick_factor=15;							
-		break;
-	    case TICKD_NORMAL:
-		$this->xtick_factor=30;			
-		break;
-	    case TICKD_SPARSE:
-		$this->xtick_factor=45;					
-		break;
-	    case TICKD_VERYSPARSE:
-		$this->xtick_factor=60;								
-		break;		
-	    default:
-		JpGraphError::RaiseL(25025,$densx);//("JpGraph: Unsupported Tick density: $densx");
-	}		
-    }
-	
-
-    // Get a string of all image map areas	
+        $this->xtick_factor=30;
+        $this->ytick_factor=25;
+        switch( $aYDensity ) {
+            case TICKD_DENSE:
+                $this->ytick_factor=12;
+                break;
+            case TICKD_NORMAL:
+                $this->ytick_factor=25;
+                break;
+            case TICKD_SPARSE:
+                $this->ytick_factor=40;
+                break;
+            case TICKD_VERYSPARSE:
+                $this->ytick_factor=100;
+                break;
+            default:
+                JpGraphError::RaiseL(25025,$densy);//("JpGraph: Unsupported Tick density: $densy");
+        }
+        switch( $aXDensity ) {
+            case TICKD_DENSE:
+                $this->xtick_factor=15;
+                break;
+            case TICKD_NORMAL:
+                $this->xtick_factor=30;
+                break;
+            case TICKD_SPARSE:
+                $this->xtick_factor=45;
+                break;
+            case TICKD_VERYSPARSE:
+                $this->xtick_factor=60;
+                break;
+            default:
+                JpGraphError::RaiseL(25025,$densx);//("JpGraph: Unsupported Tick density: $densx");
+        }
+    }
+
+
+    // Get a string of all image map areas
     function GetCSIMareas() {
-	if( !$this->iHasStroked )
-	    $this->Stroke(_CSIM_SPECIALFILE);
-
-	$csim = $this->title->GetCSIMAreas();
-	$csim .= $this->subtitle->GetCSIMAreas();
-	$csim .= $this->subsubtitle->GetCSIMAreas();
-	$csim .= $this->legend->GetCSIMAreas();
-
-	if( $this->y2axis != NULL ) {
-	    $csim .= $this->y2axis->title->GetCSIMAreas();
-	}
-
-	if( $this->texts != null ) {
-	    $n = count($this->texts);
-	    for($i=0; $i < $n; ++$i ) {
-		$csim .= $this->texts[$i]->GetCSIMAreas();
-	    }
-	}
-
-	if( $this->y2texts != null && $this->y2scale != null ) {
-	    $n = count($this->y2texts);
-	    for($i=0; $i < $n; ++$i ) {
-		$csim .= $this->y2texts[$i]->GetCSIMAreas();
-	    }
-	}
-
-	if( $this->yaxis != null && $this->xaxis != null ) {
-	    $csim .= $this->yaxis->title->GetCSIMAreas();	
-	    $csim .= $this->xaxis->title->GetCSIMAreas();
-	}
-
-	$n = count($this->plots);
-	for( $i=0; $i < $n; ++$i ) 
-	    $csim .= $this->plots[$i]->GetCSIMareas();
-
-	$n = count($this->y2plots);
-	for( $i=0; $i < $n; ++$i ) 
-	    $csim .= $this->y2plots[$i]->GetCSIMareas();
-
-	$n = count($this->ynaxis);
-	for( $i=0; $i < $n; ++$i ) {
-	    $m = count($this->ynplots[$i]); 
-	    for($j=0; $j < $m; ++$j ) {
-		$csim .= $this->ynplots[$i][$j]->GetCSIMareas();
-	    }
-	}
-
-	$n = count($this->iTables);
-	for( $i=0; $i < $n; ++$i ) {
-	    $csim .= $this->iTables[$i]->GetCSIMareas();
-	}
-
-	return $csim;
-    }
-	
+        if( !$this->iHasStroked ) {
+            $this->Stroke(_CSIM_SPECIALFILE);
+        }
+
+        $csim = $this->title->GetCSIMAreas();
+        $csim .= $this->subtitle->GetCSIMAreas();
+        $csim .= $this->subsubtitle->GetCSIMAreas();
+        $csim .= $this->legend->GetCSIMAreas();
+
+        if( $this->y2axis != NULL ) {
+            $csim .= $this->y2axis->title->GetCSIMAreas();
+        }
+
+        if( $this->texts != null ) {
+            $n = count($this->texts);
+            for($i=0; $i < $n; ++$i ) {
+                $csim .= $this->texts[$i]->GetCSIMAreas();
+            }
+        }
+
+        if( $this->y2texts != null && $this->y2scale != null ) {
+            $n = count($this->y2texts);
+            for($i=0; $i < $n; ++$i ) {
+                $csim .= $this->y2texts[$i]->GetCSIMAreas();
+            }
+        }
+
+        if( $this->yaxis != null && $this->xaxis != null ) {
+            $csim .= $this->yaxis->title->GetCSIMAreas();
+            $csim .= $this->xaxis->title->GetCSIMAreas();
+        }
+
+        $n = count($this->plots);
+        for( $i=0; $i < $n; ++$i ) {
+            $csim .= $this->plots[$i]->GetCSIMareas();
+        }
+
+        $n = count($this->y2plots);
+        for( $i=0; $i < $n; ++$i ) {
+            $csim .= $this->y2plots[$i]->GetCSIMareas();
+        }
+
+        $n = count($this->ynaxis);
+        for( $i=0; $i < $n; ++$i ) {
+            $m = count($this->ynplots[$i]);
+            for($j=0; $j < $m; ++$j ) {
+                $csim .= $this->ynplots[$i][$j]->GetCSIMareas();
+            }
+        }
+
+        if($this->iTables != null) {
+            $n = count($this->iTables);
+            for ($i = 0; $i < $n; ++$i) {
+                $csim .= $this->iTables[$i]->GetCSIMareas();
+            }
+        }
+
+        return $csim;
+    }
+
     // Get a complete <MAP>..</MAP> tag for the final image map
     function GetHTMLImageMap($aMapName) {
-	$im = "<map name=\"$aMapName\" id=\"$aMapName\" >\n";
-	$im .= $this->GetCSIMareas();
-	$im .= "</map>"; 
-	return $im;
+        $im = "<map name=\"$aMapName\" id=\"$aMapName\" >\n";
+        $im .= $this->GetCSIMareas();
+        $im .= "</map>";
+        return $im;
     }
 
     function CheckCSIMCache($aCacheName,$aTimeOut=60) {
-	global $_SERVER;
-
-	if( $aCacheName=='auto' )
-	    $aCacheName=basename($_SERVER['PHP_SELF']);
-
-	$urlarg = $this->GetURLArguments();
-	$this->csimcachename = CSIMCACHE_DIR.$aCacheName.$urlarg;
-	$this->csimcachetimeout = $aTimeOut;
-
-	// First determine if we need to check for a cached version
-	// This differs from the standard cache in the sense that the
-	// image and CSIM map HTML file is written relative to the directory
-	// the script executes in and not the specified cache directory.
-	// The reason for this is that the cache directory is not necessarily
-	// accessible from the HTTP server.
-	if( $this->csimcachename != '' ) {
-	    $dir = dirname($this->csimcachename);
-	    $base = basename($this->csimcachename);
-	    $base = strtok($base,'.');
-	    $suffix = strtok('.');
-	    $basecsim = $dir.'/'.$base.'?'.$urlarg.'_csim_.html';
-	    $baseimg = $dir.'/'.$base.'?'.$urlarg.'.'.$this->img->img_format;
-
-	    $timedout=false;
-	    // Does it exist at all ?
-	    
-	    if( file_exists($basecsim) && file_exists($baseimg) ) {
-		// Check that it hasn't timed out
-		$diff=time()-filemtime($basecsim);
-		if( $this->csimcachetimeout>0 && ($diff > $this->csimcachetimeout*60) ) {
-		    $timedout=true;
-		    @unlink($basecsim);
-		    @unlink($baseimg);
-		}
-		else {
-		    if ($fh = @fopen($basecsim, "r")) {
-			fpassthru($fh);
-			return true;
-		    }
-		    else
-			JpGraphError::RaiseL(25027,$basecsim);//(" Can't open cached CSIM \"$basecsim\" for reading.");
-		}
-	    }
-	}
-	return false;
+        global $_SERVER;
+
+        if( $aCacheName=='auto' ) {
+            $aCacheName=basename($_SERVER['PHP_SELF']);
+        }
+
+        $urlarg = $this->GetURLArguments();
+        $this->csimcachename = CSIMCACHE_DIR.$aCacheName.$urlarg;
+        $this->csimcachetimeout = $aTimeOut;
+
+        // First determine if we need to check for a cached version
+        // This differs from the standard cache in the sense that the
+        // image and CSIM map HTML file is written relative to the directory
+        // the script executes in and not the specified cache directory.
+        // The reason for this is that the cache directory is not necessarily
+        // accessible from the HTTP server.
+        if( $this->csimcachename != '' ) {
+            $dir = dirname($this->csimcachename);
+            $base = basename($this->csimcachename);
+            $base = strtok($base,'.');
+            $suffix = strtok('.');
+            $basecsim = $dir.'/'.$base.'?'.$urlarg.'_csim_.html';
+            $baseimg = $dir.'/'.$base.'?'.$urlarg.'.'.$this->img->img_format;
+
+            $timedout=false;
+            // Does it exist at all ?
+
+            if( file_exists($basecsim) && file_exists($baseimg) ) {
+                // Check that it hasn't timed out
+                $diff=time()-filemtime($basecsim);
+                if( $this->csimcachetimeout>0 && ($diff > $this->csimcachetimeout*60) ) {
+                    $timedout=true;
+                    @unlink($basecsim);
+                    @unlink($baseimg);
+                }
+                else {
+                    if ($fh = @fopen($basecsim, "r")) {
+                        fpassthru($fh);
+                        return true;
+                    }
+                    else {
+                        JpGraphError::RaiseL(25027,$basecsim);//(" Can't open cached CSIM \"$basecsim\" for reading.");
+                    }
+                }
+            }
+        }
+        return false;
     }
 
     // Build the argument string to be used with the csim images
-    function GetURLArguments() {
-		
-	// This is a JPGRAPH internal defined that prevents
-	// us from recursively coming here again
-	$urlarg = _CSIM_DISPLAY.'=1';
-
-	// Now reconstruct any user URL argument
-	reset($_GET);
-	while( list($key,$value) = each($_GET) ) {
-	    if( is_array($value) ) {
-		foreach ( $value as $k => $v ) {
-		    $urlarg .= '&amp;'.$key.'%5B'.$k.'%5D='.urlencode($v);
-		}
-	    }
-	    else {
-		$urlarg .= '&amp;'.$key.'='.urlencode($value);
-	    }
-	}
-
-	// It's not ideal to convert POST argument to GET arguments
-	// but there is little else we can do. One idea for the 
-	// future might be recreate the POST header in case.
-	reset($_POST);
-	while( list($key,$value) = each($_POST) ) {
-	    if( is_array($value) ) {
-		foreach ( $value as $k => $v ) {
-		    $urlarg .= '&amp;'.$key.'%5B'.$k.'%5D='.urlencode($v);
-		}
-	    }
-	    else {
-		$urlarg .= '&amp;'.$key.'='.urlencode($value);
-	    }
-	}
-
-	return $urlarg;
+    static function GetURLArguments($aAddRecursiveBlocker=false) {
+
+        if( $aAddRecursiveBlocker ) {
+            // This is a JPGRAPH internal defined that prevents
+            // us from recursively coming here again
+            $urlarg = _CSIM_DISPLAY.'=1';
+        }
+
+        // Now reconstruct any user URL argument
+        reset($_GET);
+        foreach ($_GET as $key => $value) {
+            if( is_array($value) ) {
+                foreach ( $value as $k => $v ) {
+                    $urlarg .= '&amp;'.$key.'%5B'.$k.'%5D='.urlencode($v);
+                }
+            }
+            else {
+                $urlarg .= '&amp;'.$key.'='.urlencode($value);
+            }
+        }
+
+        // It's not ideal to convert POST argument to GET arguments
+        // but there is little else we can do. One idea for the
+        // future might be recreate the POST header in case.
+        reset($_POST);
+        foreach ($_POST as $key => $value) {
+            if( is_array($value) ) {
+                foreach ( $value as $k => $v ) {
+                    $urlarg .= '&amp;'.$key.'%5B'.$k.'%5D='.urlencode($v);
+                }
+            }
+            else {
+                $urlarg .= '&amp;'.$key.'='.urlencode($value);
+            }
+        }
+
+        return $urlarg;
     }
 
     function SetCSIMImgAlt($aAlt) {
-	$this->iCSIMImgAlt = $aAlt;
+        $this->iCSIMImgAlt = $aAlt;
     }
 
     function StrokeCSIM($aScriptName='auto',$aCSIMName='',$aBorder=0) {
-	if( $aCSIMName=='' ) {
-	    // create a random map name
-	    srand ((double) microtime() * 1000000);
-	    $r = rand(0,100000);
-	    $aCSIMName='__mapname'.$r.'__';
-	}
-
-	if( $aScriptName=='auto' )
-	    $aScriptName=basename($_SERVER['PHP_SELF']);
-
-	$urlarg = $this->GetURLArguments();
-
-	if( empty($_GET[_CSIM_DISPLAY]) ) {
-	    // First determine if we need to check for a cached version
-	    // This differs from the standard cache in the sense that the
-	    // image and CSIM map HTML file is written relative to the directory
-	    // the script executes in and not the specified cache directory.
-	    // The reason for this is that the cache directory is not necessarily
-	    // accessible from the HTTP server.
-	    if( $this->csimcachename != '' ) {
-		$dir = dirname($this->csimcachename);
-		$base = basename($this->csimcachename);
-		$base = strtok($base,'.');
-		$suffix = strtok('.');
-		$basecsim = $dir.'/'.$base.'?'.$urlarg.'_csim_.html';
-		$baseimg = $base.'?'.$urlarg.'.'.$this->img->img_format;
-
-		// Check that apache can write to directory specified
-
-		if( file_exists($dir) && !is_writeable($dir) ) {
-		    JpgraphError::RaiseL(25028,$dir);//('Apache/PHP does not have permission to write to the CSIM cache directory ('.$dir.'). Check permissions.');
-		}
-		
-		// Make sure directory exists
-		$this->cache->MakeDirs($dir);
-
-		// Write the image file
-		$this->Stroke(CSIMCACHE_DIR.$baseimg);
-
-		// Construct wrapper HTML and write to file and send it back to browser
-
-		// In the src URL we must replace the '?' with its encoding to prevent the arguments
-		// to be converted to real arguments.
-		$tmp = str_replace('?','%3f',$baseimg);
-		$htmlwrap = $this->GetHTMLImageMap($aCSIMName)."\n".
-		    '<img src="'.CSIMCACHE_HTTP_DIR.$tmp.'" ismap="ismap" usemap="#'.$aCSIMName.'" border="'.$aBorder.'" width="'.$this->img->width.'" height="'.$this->img->height."\" alt=\"".$this->iCSIMImgAlt."\" />\n";
-
-		if($fh =  @fopen($basecsim,'w') ) {
-		    fwrite($fh,$htmlwrap);
-		    fclose($fh);
-		    echo $htmlwrap;
-		}
-		else
-		    JpGraphError::RaiseL(25029,$basecsim);//(" Can't write CSIM \"$basecsim\" for writing. Check free space and permissions.");
-	    }
-	    else {
-
-		if( $aScriptName=='' ) {
-		    JpGraphError::RaiseL(25030);//('Missing script name in call to StrokeCSIM(). You must specify the name of the actual image script as the first parameter to StrokeCSIM().');
-		}
-		echo $this->GetHTMLImageMap($aCSIMName);
-		echo "<img src=\"".$aScriptName.'?'.$urlarg."\" ismap=\"ismap\" usemap=\"#".$aCSIMName.'" border="'.$aBorder.'" width="'.$this->img->width.'" height="'.$this->img->height."\" alt=\"".$this->iCSIMImgAlt."\" />\n";
-	    }
-	}
-	else {
-	    $this->Stroke();
-	}
+        if( $aCSIMName=='' ) {
+            // create a random map name
+            srand ((double) microtime() * 1000000);
+            $r = rand(0,100000);
+            $aCSIMName='__mapname'.$r.'__';
+        }
+
+        if( $aScriptName=='auto' ) {
+            $aScriptName=basename($_SERVER['PHP_SELF']);
+        }
+
+        $urlarg = $this->GetURLArguments(true);
+
+        if( empty($_GET[_CSIM_DISPLAY]) ) {
+            // First determine if we need to check for a cached version
+            // This differs from the standard cache in the sense that the
+            // image and CSIM map HTML file is written relative to the directory
+            // the script executes in and not the specified cache directory.
+            // The reason for this is that the cache directory is not necessarily
+            // accessible from the HTTP server.
+            if( $this->csimcachename != '' ) {
+                $dir = dirname($this->csimcachename);
+                $base = basename($this->csimcachename);
+                $base = strtok($base,'.');
+                $suffix = strtok('.');
+                $basecsim = $dir.'/'.$base.'?'.$urlarg.'_csim_.html';
+                $baseimg = $base.'?'.$urlarg.'.'.$this->img->img_format;
+
+                // Check that apache can write to directory specified
+
+                if( file_exists($dir) && !is_writeable($dir) ) {
+                    JpgraphError::RaiseL(25028,$dir);//('Apache/PHP does not have permission to write to the CSIM cache directory ('.$dir.'). Check permissions.');
+                }
+
+                // Make sure directory exists
+                $this->cache->MakeDirs($dir);
+
+                // Write the image file
+                $this->Stroke(CSIMCACHE_DIR.$baseimg);
+
+                // Construct wrapper HTML and write to file and send it back to browser
+
+                // In the src URL we must replace the '?' with its encoding to prevent the arguments
+                // to be converted to real arguments.
+                $tmp = str_replace('?','%3f',$baseimg);
+                $htmlwrap = $this->GetHTMLImageMap($aCSIMName)."\n".
+                            '<img src="'.CSIMCACHE_HTTP_DIR.$tmp.'" ismap="ismap" usemap="#'.$aCSIMName.' width="'.$this->img->width.'" height="'.$this->img->height."\" alt=\"".$this->iCSIMImgAlt."\" />\n";
+
+                if($fh =  @fopen($basecsim,'w') ) {
+                    fwrite($fh,$htmlwrap);
+                    fclose($fh);
+                    echo $htmlwrap;
+                }
+                else {
+                    JpGraphError::RaiseL(25029,$basecsim);//(" Can't write CSIM \"$basecsim\" for writing. Check free space and permissions.");
+                }
+            }
+            else {
+
+                if( $aScriptName=='' ) {
+                    JpGraphError::RaiseL(25030);//('Missing script name in call to StrokeCSIM(). You must specify the name of the actual image script as the first parameter to StrokeCSIM().');
+                }
+                echo $this->GetHTMLImageMap($aCSIMName) . $this->GetCSIMImgHTML($aCSIMName, $aScriptName, $aBorder);
+            }
+        }
+        else {
+            $this->Stroke();
+        }
+    }
+
+    function StrokeCSIMImage() {
+        if( @$_GET[_CSIM_DISPLAY] == 1 ) {
+            $this->Stroke();
+        }
+    }
+
+    function GetCSIMImgHTML($aCSIMName, $aScriptName='auto', $aBorder=0 ) {
+        if( $aScriptName=='auto' ) {
+            $aScriptName=basename($_SERVER['PHP_SELF']);
+        }
+        $urlarg = $this->GetURLArguments(true);
+        return "<img src=\"".$aScriptName.'?'.$urlarg."\" ismap=\"ismap\" usemap=\"#".$aCSIMName.'" height="'.$this->img->height."\" alt=\"".$this->iCSIMImgAlt."\" />\n";
     }
 
     function GetTextsYMinMax($aY2=false) {
-	if( $aY2 ) 
-	    $txts = $this->y2texts;
-	else
-	    $txts = $this->texts;
-	$n = count($txts);
-	$min=null;
-	$max=null;
-	for( $i=0; $i < $n; ++$i ) {
-	    if( $txts[$i]->iScalePosY !== null && 
-		$txts[$i]->iScalePosX !== null  ) {
-		if( $min === null  ) {
-		    $min = $max = $txts[$i]->iScalePosY ;
-		}
-		else {
-		    $min = min($min,$txts[$i]->iScalePosY);
-		    $max = max($max,$txts[$i]->iScalePosY);
-		}
-	    }
-	}
-	if( $min !== null ) {
-	    return array($min,$max);
-	}
-	else
-	    return null;
+        if( $aY2 ) {
+            $txts = $this->y2texts;
+        }
+        else {
+            $txts = $this->texts;
+        }
+        $n = is_array($txts) ? count($txts) : 0;
+        $min=null;
+        $max=null;
+        for( $i=0; $i < $n; ++$i ) {
+            if( $txts[$i]->iScalePosY !== null && $txts[$i]->iScalePosX !== null  ) {
+                if( $min === null  ) {
+                    $min = $max = $txts[$i]->iScalePosY ;
+                }
+                else {
+                    $min = min($min,$txts[$i]->iScalePosY);
+                    $max = max($max,$txts[$i]->iScalePosY);
+                }
+            }
+        }
+        if( $min !== null ) {
+            return array($min,$max);
+        }
+        else {
+            return null;
+        }
     }
 
     function GetTextsXMinMax($aY2=false) {
-	if( $aY2 ) 
-	    $txts = $this->y2texts;
-	else
-	    $txts = $this->texts;
-	$n = count($txts);
-	$min=null;
-	$max=null;
-	for( $i=0; $i < $n; ++$i ) {
-	    if( $txts[$i]->iScalePosY !== null && 
-		$txts[$i]->iScalePosX !== null  ) {
-		if( $min === null  ) {
-		    $min = $max = $txts[$i]->iScalePosX ;
-		}
-		else {
-		    $min = min($min,$txts[$i]->iScalePosX);
-		    $max = max($max,$txts[$i]->iScalePosX);
-		}
-	    }
-	}
-	if( $min !== null ) {
-	    return array($min,$max);
-	}
-	else
-	    return null;
+        if( $aY2 ) {
+            $txts = $this->y2texts;
+        }
+        else {
+            $txts = $this->texts;
+        }
+        $n = is_array($txts) ? count($txts) : 0;
+        $min=null;
+        $max=null;
+        for( $i=0; $i < $n; ++$i ) {
+            if( $txts[$i]->iScalePosY !== null && $txts[$i]->iScalePosX !== null  ) {
+                if( $min === null  ) {
+                    $min = $max = $txts[$i]->iScalePosX ;
+                }
+                else {
+                    $min = min($min,$txts[$i]->iScalePosX);
+                    $max = max($max,$txts[$i]->iScalePosX);
+                }
+            }
+        }
+        if( $min !== null ) {
+            return array($min,$max);
+        }
+        else {
+            return null;
+        }
     }
 
     function GetXMinMax() {
-	list($min,$ymin) = $this->plots[0]->Min();
-	list($max,$ymax) = $this->plots[0]->Max();
-	foreach( $this->plots as $p ) {
-	    list($xmin,$ymin) = $p->Min();
-	    list($xmax,$ymax) = $p->Max();			
-	    $min = Min($xmin,$min);
-	    $max = Max($xmax,$max);
-	}
-
-	if( $this->y2axis != null ) {
-	    foreach( $this->y2plots as $p ) {
-		list($xmin,$ymin) = $p->Min();
-			list($xmax,$ymax) = $p->Max();			
-			$min = Min($xmin,$min);
-			$max = Max($xmax,$max);
-	    }		    
-	}
-
-	$n = count($this->ynaxis);
-	for( $i=0; $i < $n; ++$i ) {
-	    if( $this->ynaxis[$i] != null) {
-		foreach( $this->ynplots[$i] as $p ) {
-		    list($xmin,$ymin) = $p->Min();
-		    list($xmax,$ymax) = $p->Max();			
-		    $min = Min($xmin,$min);
-		    $max = Max($xmax,$max);
-		}		    
-	    }
-	}
-	return array($min,$max);
+
+        list($min,$ymin) = $this->plots[0]->Min();
+        list($max,$ymax) = $this->plots[0]->Max();
+
+        $i=0;
+        // Some plots, e.g. PlotLine should not affect the scale
+        // and will return (null,null). We should ignore those
+        // values.
+        while( ($min===null || $max === null) && ($i < count($this->plots)-1) ) {
+            ++$i;
+            list($min,$ymin) = $this->plots[$i]->Min();
+            list($max,$ymax) = $this->plots[$i]->Max();
+        }
+
+        foreach( $this->plots as $p ) {
+            list($xmin,$ymin) = $p->Min();
+            list($xmax,$ymax) = $p->Max();
+
+            if( $xmin !== null && $xmax !== null ) {
+                $min = Min($xmin,$min);
+                $max = Max($xmax,$max);
+            }
+        }
+
+        if( $this->y2axis != null ) {
+            foreach( $this->y2plots as $p ) {
+                list($xmin,$ymin) = $p->Min();
+                list($xmax,$ymax) = $p->Max();
+                if( $xmin !== null && $xmax !== null ) {
+                    $min = Min($xmin, $min);
+                    $max = Max($xmax, $max);
+                }
+            }
+        }
+
+        $n = count($this->ynaxis);
+        for( $i=0; $i < $n; ++$i ) {
+            if( $this->ynaxis[$i] != null) {
+                foreach( $this->ynplots[$i] as $p ) {
+                    list($xmin,$ymin) = $p->Min();
+                    list($xmax,$ymax) = $p->Max();
+                    if( $xmin !== null && $xmax !== null ) {
+                        $min = Min($xmin, $min);
+                        $max = Max($xmax, $max);
+                    }
+                }
+            }
+        }
+        return array($min,$max);
     }
 
     function AdjustMarginsForTitles() {
-	$totrequired = 
-	    ($this->title->t != '' ? 
-	     $this->title->GetTextHeight($this->img) + $this->title->margin + 5 : 0 ) +
-	    ($this->subtitle->t != '' ? 
-	     $this->subtitle->GetTextHeight($this->img) + $this->subtitle->margin + 5 : 0 ) + 
-	    ($this->subsubtitle->t != '' ? 
-	     $this->subsubtitle->GetTextHeight($this->img) + $this->subsubtitle->margin + 5 : 0 ) ;
-	
-
-	$btotrequired = 0;
-	if($this->xaxis != null &&  !$this->xaxis->hide && !$this->xaxis->hide_labels ) {
-	    // Minimum bottom margin
-	    if( $this->xaxis->title->t != '' ) {
-		if( $this->img->a == 90 ) 
-		    $btotrequired = $this->yaxis->title->GetTextHeight($this->img) + 5 ;
-		else
-		    $btotrequired = $this->xaxis->title->GetTextHeight($this->img) + 5 ;
-	    }
-	    else
-		$btotrequired = 0;
-	    
-	    if( $this->img->a == 90 ) {
-		$this->img->SetFont($this->yaxis->font_family,$this->yaxis->font_style,
-				    $this->yaxis->font_size);
-		$lh = $this->img->GetTextHeight('Mg',$this->yaxis->label_angle);
-	    }
-	    else {
-		$this->img->SetFont($this->xaxis->font_family,$this->xaxis->font_style,
-				    $this->xaxis->font_size);
-		$lh = $this->img->GetTextHeight('Mg',$this->xaxis->label_angle);
-	    }
-	    
-	    $btotrequired += $lh + 5;
-	}
-
-	if( $this->img->a == 90 ) {
-	    // DO Nothing. It gets too messy to do this properly for 90 deg...
-	}
-	else{
-	    if( $this->img->top_margin < $totrequired ) {
-		$this->SetMargin($this->img->left_margin,$this->img->right_margin,
-				 $totrequired,$this->img->bottom_margin);
-	    }
-	    if( $this->img->bottom_margin < $btotrequired ) {
-		$this->SetMargin($this->img->left_margin,$this->img->right_margin,
-				 $this->img->top_margin,$btotrequired);
-	    }
-	}
-    }
+        $totrequired = 
+            ($this->title->t != '' 
+                ? $this->title->GetTextHeight($this->img) + $this->title->margin + 5 * SUPERSAMPLING_SCALE
+                : 0 ) +
+            ($this->subtitle->t != '' 
+                ? $this->subtitle->GetTextHeight($this->img) + $this->subtitle->margin + 5 * SUPERSAMPLING_SCALE
+                : 0 ) +
+            ($this->subsubtitle->t != '' 
+                ? $this->subsubtitle->GetTextHeight($this->img) + $this->subsubtitle->margin + 5 * SUPERSAMPLING_SCALE
+                : 0 ) ;
+
+        $btotrequired = 0;
+        if($this->xaxis != null &&  !$this->xaxis->hide && !$this->xaxis->hide_labels ) {
+            // Minimum bottom margin
+            if( $this->xaxis->title->t != '' ) {
+                if( $this->img->a == 90 ) {
+                    $btotrequired = $this->yaxis->title->GetTextHeight($this->img) + 7 ;
+                }
+                else {
+                    $btotrequired = $this->xaxis->title->GetTextHeight($this->img) + 7 ;
+                }
+            }
+            else {
+                $btotrequired = 0;
+            }
+
+            if( $this->img->a == 90 ) {
+                $this->img->SetFont($this->yaxis->font_family,$this->yaxis->font_style,
+                $this->yaxis->font_size);
+                $lh = $this->img->GetTextHeight('Mg',$this->yaxis->label_angle);
+            }
+            else {
+                $this->img->SetFont($this->xaxis->font_family,$this->xaxis->font_style,
+                $this->xaxis->font_size);
+                $lh = $this->img->GetTextHeight('Mg',$this->xaxis->label_angle);
+            }
+
+            $btotrequired += $lh + 6;
+        }
+
+        if( $this->img->a == 90 ) {
+            // DO Nothing. It gets too messy to do this properly for 90 deg...
+        }
+        else{
+            // need more top margin
+            if( $this->img->top_margin < $totrequired ) {
+                $this->SetMargin(
+                    $this->img->raw_left_margin,
+                    $this->img->raw_right_margin,
+                    $totrequired / SUPERSAMPLING_SCALE, 
+                    $this->img->raw_bottom_margin
+                );
+            }
+
+            // need more bottom margin
+            if( $this->img->bottom_margin < $btotrequired ) {
+                $this->SetMargin(
+                    $this->img->raw_left_margin,
+                    $this->img->raw_right_margin,
+                    $this->img->raw_top_margin,
+                    $btotrequired / SUPERSAMPLING_SCALE
+                );
+            }
+        }
+    }
+
+    function StrokeStore($aStrokeFileName) {
+        // Get the handler to prevent the library from sending the
+        // image to the browser
+        $ih = $this->Stroke(_IMG_HANDLER);
+
+        // Stroke it to a file
+        $this->img->Stream($aStrokeFileName);
+
+        // Send it back to browser
+        $this->img->Headers();
+        $this->img->Stream();
+    }
+
+    function doAutoscaleXAxis() {
+    //Check if we should autoscale x-axis
+        if( !$this->xscale->IsSpecified() ) {
+            if( substr($this->axtype,0,4) == "text" ) {
+                $max=0;
+                $n = count($this->plots);
+                for($i=0; $i < $n; ++$i ) {
+                    $p = $this->plots[$i];
+                    // We need some unfortunate sub class knowledge here in order
+                    // to increase number of data points in case it is a line plot
+                    // which has the barcenter set. If not it could mean that the
+                    // last point of the data is outside the scale since the barcenter
+                    // settings means that we will shift the entire plot half a tick step
+                    // to the right in oder to align with the center of the bars.
+                    if( class_exists('BarPlot',false) ) {
+                        $cl = strtolower(get_class($p));
+                        if( (class_exists('BarPlot',false) && ($p instanceof BarPlot)) || empty($p->barcenter) ) {
+                            $max=max($max,$p->numpoints-1);
+                        }
+                        else {
+                            $max=max($max,$p->numpoints);
+                        }
+                    }
+                    else {
+                        if( empty($p->barcenter) ) {
+                            $max=max($max,$p->numpoints-1);
+                        }
+                        else {
+                            $max=max($max,$p->numpoints);
+                        }
+                    }
+                }
+                $min=0;
+                if( $this->y2axis != null ) {
+                    foreach( $this->y2plots as $p ) {
+                        $max=max($max,$p->numpoints-1);
+                    }
+                }
+                $n = count($this->ynaxis);
+                for( $i=0; $i < $n; ++$i ) {
+                    if( $this->ynaxis[$i] != null) {
+                        foreach( $this->ynplots[$i] as $p ) {
+                            $max=max($max,$p->numpoints-1);
+                        }
+                    }
+                }
+
+                $this->xscale->Update($this->img,$min,$max);
+                $this->xscale->ticks->Set($this->xaxis->tick_step,1);
+                $this->xscale->ticks->SupressMinorTickMarks();
+            }
+            else {
+                list($min,$max) = $this->GetXMinMax();
+
+                $lres = $this->GetLinesXMinMax($this->lines);
+                if( $lres ) {
+                    list($linmin,$linmax) = $lres ;
+                    $min = min($min,$linmin);
+                    $max = max($max,$linmax);
+                }
+
+                $lres = $this->GetLinesXMinMax($this->y2lines);
+                if( $lres ) {
+                    list($linmin,$linmax) = $lres ;
+                    $min = min($min,$linmin);
+                    $max = max($max,$linmax);
+                }
+
+                $tres = $this->GetTextsXMinMax();
+                if( $tres ) {
+                    list($tmin,$tmax) = $tres ;
+                    $min = min($min,$tmin);
+                    $max = max($max,$tmax);
+                }
+
+                $tres = $this->GetTextsXMinMax(true);
+                if( $tres ) {
+                    list($tmin,$tmax) = $tres ;
+                    $min = min($min,$tmin);
+                    $max = max($max,$tmax);
+                }
+
+                $this->xscale->AutoScale($this->img,$min,$max,round($this->img->plotwidth/$this->xtick_factor));
+            }
+
+            //Adjust position of y-axis and y2-axis to minimum/maximum of x-scale
+            if( !is_numeric($this->yaxis->pos) && !is_string($this->yaxis->pos) ) {
+                $this->yaxis->SetPos($this->xscale->GetMinVal());
+            }
+        }
+        elseif( $this->xscale->IsSpecified() &&
+                ( $this->xscale->auto_ticks || !$this->xscale->ticks->IsSpecified()) ) {
+            // The tick calculation will use the user suplied min/max values to determine
+            // the ticks. If auto_ticks is false the exact user specifed min and max
+            // values will be used for the scale.
+            // If auto_ticks is true then the scale might be slightly adjusted
+            // so that the min and max values falls on an even major step.
+            $min = $this->xscale->scale[0];
+            $max = $this->xscale->scale[1];
+            $this->xscale->AutoScale($this->img,$min,$max,round($this->img->plotwidth/$this->xtick_factor),false);
+
+            // Now make sure we show enough precision to accurate display the
+            // labels. If this is not done then the user might end up with
+            // a scale that might actually start with, say 13.5, butdue to rounding
+            // the scale label will ony show 14.
+            if( abs(floor($min)-$min) > 0 ) {
+
+                // If the user has set a format then we bail out
+                if( $this->xscale->ticks->label_formatstr == '' && $this->xscale->ticks->label_dateformatstr == '' ) {
+                    $this->xscale->ticks->precision = abs( floor(log10( abs(floor($min)-$min))) )+1;
+                }
+            }
+        }
+
+        // Position the optional Y2 and Yn axis to the rightmost position of the x-axis
+        if( $this->y2axis != null ) {
+            if( !is_numeric($this->y2axis->pos) && !is_string($this->y2axis->pos) ) {
+                $this->y2axis->SetPos($this->xscale->GetMaxVal());
+            }
+            $this->y2axis->SetTitleSide(SIDE_RIGHT);
+        }
+
+        $n = count($this->ynaxis);
+        $nY2adj = $this->y2axis != null ? $this->iYAxisDeltaPos : 0;
+        for( $i=0; $i < $n; ++$i ) {
+            if( $this->ynaxis[$i] != null ) {
+                if( !is_numeric($this->ynaxis[$i]->pos) && !is_string($this->ynaxis[$i]->pos) ) {
+                    $this->ynaxis[$i]->SetPos($this->xscale->GetMaxVal());
+                    $this->ynaxis[$i]->SetPosAbsDelta($i*$this->iYAxisDeltaPos + $nY2adj);
+                }
+                $this->ynaxis[$i]->SetTitleSide(SIDE_RIGHT);
+            }
+        }
+    }
+
+
+    function doAutoScaleYnAxis() {
+
+        if( $this->y2scale != null) {
+            if( !$this->y2scale->IsSpecified() && count($this->y2plots)>0 ) {
+                list($min,$max) = $this->GetPlotsYMinMax($this->y2plots);
+
+                $lres = $this->GetLinesYMinMax($this->y2lines);
+                if( is_array($lres) ) {
+                    list($linmin,$linmax) = $lres ;
+                    $min = min($min,$linmin);
+                    $max = max($max,$linmax);
+                }
+                $tres = $this->GetTextsYMinMax(true);
+                if( is_array($tres) ) {
+                    list($tmin,$tmax) = $tres ;
+                    $min = min($min,$tmin);
+                    $max = max($max,$tmax);
+                }
+                $this->y2scale->AutoScale($this->img,$min,$max,$this->img->plotheight/$this->ytick_factor);
+            }
+            elseif( $this->y2scale->IsSpecified() && ( $this->y2scale->auto_ticks || !$this->y2scale->ticks->IsSpecified()) ) {
+                // The tick calculation will use the user suplied min/max values to determine
+                // the ticks. If auto_ticks is false the exact user specifed min and max
+                // values will be used for the scale.
+                // If auto_ticks is true then the scale might be slightly adjusted
+                // so that the min and max values falls on an even major step.
+                $min = $this->y2scale->scale[0];
+                $max = $this->y2scale->scale[1];
+                $this->y2scale->AutoScale($this->img,$min,$max,
+                $this->img->plotheight/$this->ytick_factor,
+                $this->y2scale->auto_ticks);
+
+                // Now make sure we show enough precision to accurate display the
+                // labels. If this is not done then the user might end up with
+                // a scale that might actually start with, say 13.5, butdue to rounding
+                // the scale label will ony show 14.
+                if( abs(floor($min)-$min) > 0 ) {
+                    // If the user has set a format then we bail out
+                    if( $this->y2scale->ticks->label_formatstr == '' && $this->y2scale->ticks->label_dateformatstr == '' ) {
+                        $this->y2scale->ticks->precision = abs( floor(log10( abs(floor($min)-$min))) )+1;
+                    }
+                }
+
+            }
+        }
+
+
+        //
+        // Autoscale the extra Y-axises
+        //
+        $n = count($this->ynaxis);
+        for( $i=0; $i < $n; ++$i ) {
+            if( $this->ynscale[$i] != null) {
+                if( !$this->ynscale[$i]->IsSpecified() && count($this->ynplots[$i])>0 ) {
+                    list($min,$max) = $this->GetPlotsYMinMax($this->ynplots[$i]);
+                    $this->ynscale[$i]->AutoScale($this->img,$min,$max,$this->img->plotheight/$this->ytick_factor);
+                }
+                elseif( $this->ynscale[$i]->IsSpecified() && ( $this->ynscale[$i]->auto_ticks || !$this->ynscale[$i]->ticks->IsSpecified()) ) {
+                    // The tick calculation will use the user suplied min/max values to determine
+                    // the ticks. If auto_ticks is false the exact user specifed min and max
+                    // values will be used for the scale.
+                    // If auto_ticks is true then the scale might be slightly adjusted
+                    // so that the min and max values falls on an even major step.
+                    $min = $this->ynscale[$i]->scale[0];
+                    $max = $this->ynscale[$i]->scale[1];
+                    $this->ynscale[$i]->AutoScale($this->img,$min,$max,
+                    $this->img->plotheight/$this->ytick_factor,
+                    $this->ynscale[$i]->auto_ticks);
+
+                    // Now make sure we show enough precision to accurate display the
+                    // labels. If this is not done then the user might end up with
+                    // a scale that might actually start with, say 13.5, butdue to rounding
+                    // the scale label will ony show 14.
+                    if( abs(floor($min)-$min) > 0 ) {
+                        // If the user has set a format then we bail out
+                        if( $this->ynscale[$i]->ticks->label_formatstr == '' && $this->ynscale[$i]->ticks->label_dateformatstr == '' ) {
+                            $this->ynscale[$i]->ticks->precision = abs( floor(log10( abs(floor($min)-$min))) )+1;
+                        }
+                    }
+                }
+            }
+        }
+    }
+
+    function doAutoScaleYAxis() {
+
+        //Check if we should autoscale y-axis
+        if( !$this->yscale->IsSpecified() && count($this->plots)>0 ) {
+            list($min,$max) = $this->GetPlotsYMinMax($this->plots);
+            $lres = $this->GetLinesYMinMax($this->lines);
+            if( is_array($lres) ) {
+                list($linmin,$linmax) = $lres ;
+                $min = min($min,$linmin);
+                $max = max($max,$linmax);
+            }
+            $tres = $this->GetTextsYMinMax();
+            if( is_array($tres) ) {
+                list($tmin,$tmax) = $tres ;
+                $min = min($min,$tmin);
+                $max = max($max,$tmax);
+            }
+            $this->yscale->AutoScale($this->img,$min,$max,
+            $this->img->plotheight/$this->ytick_factor);
+        }
+        elseif( $this->yscale->IsSpecified() && ( $this->yscale->auto_ticks || !$this->yscale->ticks->IsSpecified()) ) {
+            // The tick calculation will use the user suplied min/max values to determine
+            // the ticks. If auto_ticks is false the exact user specifed min and max
+            // values will be used for the scale.
+            // If auto_ticks is true then the scale might be slightly adjusted
+            // so that the min and max values falls on an even major step.
+            $min = $this->yscale->scale[0];
+            $max = $this->yscale->scale[1];
+            $this->yscale->AutoScale($this->img,$min,$max,
+            $this->img->plotheight/$this->ytick_factor,
+            $this->yscale->auto_ticks);
+
+            // Now make sure we show enough precision to accurate display the
+            // labels. If this is not done then the user might end up with
+            // a scale that might actually start with, say 13.5, butdue to rounding
+            // the scale label will ony show 14.
+            if( abs(floor($min)-$min) > 0 ) {
+
+                // If the user has set a format then we bail out
+                if( $this->yscale->ticks->label_formatstr == '' && $this->yscale->ticks->label_dateformatstr == '' ) {
+                    $this->yscale->ticks->precision = abs( floor(log10( abs(floor($min)-$min))) )+1;
+                }
+            }
+        }
+
+    }
+
+    function InitScaleConstants() {
+        // Setup scale constants
+        if( $this->yscale ) $this->yscale->InitConstants($this->img);
+        if( $this->xscale ) $this->xscale->InitConstants($this->img);
+        if( $this->y2scale ) $this->y2scale->InitConstants($this->img);
+
+        $n=count($this->ynscale);
+        for($i=0; $i < $n; ++$i) {
+            if( $this->ynscale[$i] ) {
+                $this->ynscale[$i]->InitConstants($this->img);
+            }
+        }
+    }
+
+    function doPrestrokeAdjustments() {
+
+        // Do any pre-stroke adjustment that is needed by the different plot types
+        // (i.e bar plots want's to add an offset to the x-labels etc)
+        for($i=0; $i < count($this->plots) ; ++$i ) {
+            $this->plots[$i]->PreStrokeAdjust($this);
+            $this->plots[$i]->DoLegend($this);
+        }
+
+        // Any plots on the second Y scale?
+        if( $this->y2scale != null ) {
+            for($i=0; $i<count($this->y2plots) ; ++$i ) {
+                $this->y2plots[$i]->PreStrokeAdjust($this);
+                $this->y2plots[$i]->DoLegend($this);
+            }
+        }
+
+        // Any plots on the extra Y axises?
+        $n = count($this->ynaxis);
+        for($i=0; $i<$n ; ++$i ) {
+            if( $this->ynplots == null || $this->ynplots[$i] == null) {
+                JpGraphError::RaiseL(25032,$i);//("No plots for Y-axis nbr:$i");
+            }
+            $m = count($this->ynplots[$i]);
+            for($j=0; $j < $m; ++$j ) {
+                $this->ynplots[$i][$j]->PreStrokeAdjust($this);
+                $this->ynplots[$i][$j]->DoLegend($this);
+            }
+        }
+    }
+
+    function StrokeBands($aDepth,$aCSIM) {
+    // Stroke bands
+        if( $this->bands != null && !$aCSIM) {
+            for($i=0; $i < count($this->bands); ++$i) {
+            // Stroke all bands that asks to be in the background
+                if( $this->bands[$i]->depth == $aDepth ) {
+                    $this->bands[$i]->Stroke($this->img,$this->xscale,$this->yscale);
+                }
+            }
+        }
+
+        if( $this->y2bands != null && $this->y2scale != null && !$aCSIM ) {
+            for($i=0; $i < count($this->y2bands); ++$i) {
+            // Stroke all bands that asks to be in the foreground
+                if( $this->y2bands[$i]->depth == $aDepth ) {
+                    $this->y2bands[$i]->Stroke($this->img,$this->xscale,$this->y2scale);
+                }
+            }
+        }
+    }
+
 
     // Stroke the graph
-    // $aStrokeFileName	If != "" the image will be written to this file and NOT
+    // $aStrokeFileName If != "" the image will be written to this file and NOT
     // streamed back to the browser
-    function Stroke($aStrokeFileName="") {		
-
-	// Fist make a sanity check that user has specified a scale
-	if( empty($this->yscale) ) {
-	    JpGraphError::RaiseL(25031);//('You must specify what scale to use with a call to Graph::SetScale().');
-	}
-
-	// Start by adjusting the margin so that potential titles will fit.
-	$this->AdjustMarginsForTitles();
-
-	// Setup scale constants
-	if( $this->yscale ) $this->yscale->InitConstants($this->img);
-	if( $this->xscale ) $this->xscale->InitConstants($this->img);
-	if( $this->y2scale ) $this->y2scale->InitConstants($this->img);
-	
-	$n=count($this->ynscale);
-	for($i=0; $i < $n; ++$i) {
-	  if( $this->ynscale[$i] ) $this->ynscale[$i]->InitConstants($this->img);
-	}
-
-	// If the filename is the predefined value = '_csim_special_'
-	// we assume that the call to stroke only needs to do enough
-	// to correctly generate the CSIM maps.
-	// We use this variable to skip things we don't strictly need
-	// to do to generate the image map to improve performance
-	// a best we can. Therefor you will see a lot of tests !$_csim in the
-	// code below.
-	$_csim = ($aStrokeFileName===_CSIM_SPECIALFILE);
-
-	// We need to know if we have stroked the plot in the
-	// GetCSIMareas. Otherwise the CSIM hasn't been generated
-	// and in the case of GetCSIM called before stroke to generate
-	// CSIM without storing an image to disk GetCSIM must call Stroke.
-	$this->iHasStroked = true;
-
-	// Do any pre-stroke adjustment that is needed by the different plot types
-	// (i.e bar plots want's to add an offset to the x-labels etc)
-	for($i=0; $i < count($this->plots) ; ++$i ) {
-	    $this->plots[$i]->PreStrokeAdjust($this);
-	    $this->plots[$i]->DoLegend($this);
-	}
-		
-	// Any plots on the second Y scale?
-	if( $this->y2scale != null ) {
-	    for($i=0; $i<count($this->y2plots)	; ++$i ) {
-		$this->y2plots[$i]->PreStrokeAdjust($this);
-		$this->y2plots[$i]->DoLegend($this);
-	    }
-	}
-
-	// Any plots on the extra Y axises?
-	$n = count($this->ynaxis);
-	for($i=0; $i<$n	; ++$i ) {
-	    if( $this->ynplots == null || $this->ynplots[$i] == null) {
-		JpGraphError::RaiseL(25032,$i);//("No plots for Y-axis nbr:$i");
-	    } 
-	    $m = count($this->ynplots[$i]); 
-	    for($j=0; $j < $m; ++$j ) {
-		$this->ynplots[$i][$j]->PreStrokeAdjust($this);
-		$this->ynplots[$i][$j]->DoLegend($this);
-	    }
-	}
-
-	// Bail out if any of the Y-axis not been specified and
-	// has no plots. (This means it is impossible to do autoscaling and
-	// no other scale was given so we can't possible draw anything). If you use manual
-	// scaling you also have to supply the tick steps as well.
-	if( (!$this->yscale->IsSpecified() && count($this->plots)==0) ||
-	    ($this->y2scale!=null && !$this->y2scale->IsSpecified() && count($this->y2plots)==0) ) {
-	    //$e = "n=".count($this->y2plots)."\n";
-	    // $e = "Can't draw unspecified Y-scale.<br>\nYou have either:<br>\n";
-	    // $e .= "1. Specified an Y axis for autoscaling but have not supplied any plots<br>\n";
-	    // $e .= "2. Specified a scale manually but have forgot to specify the tick steps";
-	    JpGraphError::RaiseL(25026);
-	}
-		
-	// Bail out if no plots and no specified X-scale
-	if( (!$this->xscale->IsSpecified() && count($this->plots)==0 && count($this->y2plots)==0) )
-	    JpGraphError::RaiseL(25034);//("<strong>JpGraph: Can't draw unspecified X-scale.</strong><br>No plots.<br>");
-
-	//Check if we should autoscale y-axis
-	if( !$this->yscale->IsSpecified() && count($this->plots)>0 ) {
-	    list($min,$max) = $this->GetPlotsYMinMax($this->plots);
- 	    $lres = $this->GetLinesYMinMax($this->lines);
-	    if( is_array($lres) ) {
-		list($linmin,$linmax) = $lres ;
-		$min = min($min,$linmin);
-		$max = max($max,$linmax);
-	    }
-	    $tres = $this->GetTextsYMinMax();
-	    if( is_array($tres) ) {
-		list($tmin,$tmax) = $tres ;
-		$min = min($min,$tmin);
-		$max = max($max,$tmax);
-	    }
-	    $this->yscale->AutoScale($this->img,$min,$max,
-				     $this->img->plotheight/$this->ytick_factor);
-	}
-	elseif( $this->yscale->IsSpecified() && 
-		( $this->yscale->auto_ticks || !$this->yscale->ticks->IsSpecified()) ) {
-	    // The tick calculation will use the user suplied min/max values to determine
-	    // the ticks. If auto_ticks is false the exact user specifed min and max
-	    // values will be used for the scale. 
-	    // If auto_ticks is true then the scale might be slightly adjusted
-	    // so that the min and max values falls on an even major step.
-	    $min = $this->yscale->scale[0];
-	    $max = $this->yscale->scale[1];
-	    $this->yscale->AutoScale($this->img,$min,$max,
-				     $this->img->plotheight/$this->ytick_factor,
-				     $this->yscale->auto_ticks);
-
-	    // Now make sure we show enough precision to accurate display the
-	    // labels. If this is not done then the user might end up with
-	    // a scale that might actually start with, say 13.5, butdue to rounding
-	    // the scale label will ony show 14.
-	    if( abs(floor($min)-$min) > 0 ) {
-		
-		// If the user has set a format then we bail out
-		if( $this->yscale->ticks->label_formatstr == '' && $this->yscale->ticks->label_dateformatstr == '' ) {
-		    $this->yscale->ticks->precision = abs( floor(log10( abs(floor($min)-$min))) )+1;
-		}
-	    }
-	}
-
-	if( $this->y2scale != null) {
-	    if( !$this->y2scale->IsSpecified() && count($this->y2plots)>0 ) {
-		list($min,$max) = $this->GetPlotsYMinMax($this->y2plots);
-
-		$lres = $this->GetLinesYMinMax($this->y2lines);
-		if( is_array($lres) ) {
-		    list($linmin,$linmax) = $lres ;
-		    $min = min($min,$linmin);
-		    $max = max($max,$linmax);
-		}
-		$tres = $this->GetTextsYMinMax(true);
-		if( is_array($tres) ) {
-		    list($tmin,$tmax) = $tres ;
-		    $min = min($min,$tmin);
-		    $max = max($max,$tmax);
-		}
-		$this->y2scale->AutoScale($this->img,$min,$max,$this->img->plotheight/$this->ytick_factor);
-	    }			
-	    elseif( $this->y2scale->IsSpecified() && 
-		    ( $this->y2scale->auto_ticks || !$this->y2scale->ticks->IsSpecified()) ) {
-		// The tick calculation will use the user suplied min/max values to determine
-		// the ticks. If auto_ticks is false the exact user specifed min and max
-		// values will be used for the scale. 
-		// If auto_ticks is true then the scale might be slightly adjusted
-		// so that the min and max values falls on an even major step.
-		$min = $this->y2scale->scale[0];
-		$max = $this->y2scale->scale[1];
-		$this->y2scale->AutoScale($this->img,$min,$max,
-					  $this->img->plotheight/$this->ytick_factor,
-					  $this->y2scale->auto_ticks);
-
-	    // Now make sure we show enough precision to accurate display the
-	    // labels. If this is not done then the user might end up with
-	    // a scale that might actually start with, say 13.5, butdue to rounding
-	    // the scale label will ony show 14.
-	    if( abs(floor($min)-$min) > 0 ) {
-		
-		// If the user has set a format then we bail out
-		if( $this->y2scale->ticks->label_formatstr == '' && $this->y2scale->ticks->label_dateformatstr == '' ) {
-		    $this->y2scale->ticks->precision = abs( floor(log10( abs(floor($min)-$min))) )+1;
-		}
-	    }
-
-	    }
-	}
-				
-	//
-	// Autoscale the extra Y-axises
-	//
-	$n = count($this->ynaxis);
-	for( $i=0; $i < $n; ++$i ) {
-	  if( $this->ynscale[$i] != null) {
-	    if( !$this->ynscale[$i]->IsSpecified() && count($this->ynplots[$i])>0 ) {
-	      list($min,$max) = $this->GetPlotsYMinMax($this->ynplots[$i]);
-	      $this->ynscale[$i]->AutoScale($this->img,$min,$max,$this->img->plotheight/$this->ytick_factor);
-	    }			
-	    elseif( $this->ynscale[$i]->IsSpecified() && 
-		    ( $this->ynscale[$i]->auto_ticks || !$this->ynscale[$i]->ticks->IsSpecified()) ) {
-		// The tick calculation will use the user suplied min/max values to determine
-		// the ticks. If auto_ticks is false the exact user specifed min and max
-		// values will be used for the scale. 
-		// If auto_ticks is true then the scale might be slightly adjusted
-		// so that the min and max values falls on an even major step.
-	      $min = $this->ynscale[$i]->scale[0];
-	      $max = $this->ynscale[$i]->scale[1];
-	      $this->ynscale[$i]->AutoScale($this->img,$min,$max,
-					    $this->img->plotheight/$this->ytick_factor,
-					    $this->ynscale[$i]->auto_ticks);
-
-	      // Now make sure we show enough precision to accurate display the
-	      // labels. If this is not done then the user might end up with
-	      // a scale that might actually start with, say 13.5, butdue to rounding
-	      // the scale label will ony show 14.
-	      if( abs(floor($min)-$min) > 0 ) {
-		
-		  // If the user has set a format then we bail out
-		  if( $this->ynscale[$i]->ticks->label_formatstr == '' && $this->ynscale[$i]->ticks->label_dateformatstr == '' ) {
-		      $this->ynscale[$i]->ticks->precision = abs( floor(log10( abs(floor($min)-$min))) )+1;
-		  }
-	      }
-
-	    }
-	  }
-	}
-		
-	//Check if we should autoscale x-axis
-	if( !$this->xscale->IsSpecified() ) {
-	    if( substr($this->axtype,0,4) == "text" ) {
-		$max=0;
-		$n = count($this->plots);
-		for($i=0; $i < $n; ++$i ) {
-		    $p = $this->plots[$i];
-		    // We need some unfortunate sub class knowledge here in order
-		    // to increase number of data points in case it is a line plot
-		    // which has the barcenter set. If not it could mean that the
-		    // last point of the data is outside the scale since the barcenter
-		    // settings means that we will shift the entire plot half a tick step
-		    // to the right in oder to align with the center of the bars.
-		    if( class_exists('BarPlot',false) ) {
-			$cl = strtolower(get_class($p));
-			if( (class_exists('BarPlot',false) && ($p instanceof BarPlot)) || 
-			    empty($p->barcenter) ) 
-			    $max=max($max,$p->numpoints-1);
-			else {
-			    $max=max($max,$p->numpoints);
-			}
-		    }
-		    else {
-			if( empty($p->barcenter) ) {
-			    $max=max($max,$p->numpoints-1);
-			}
-			else {
-			    $max=max($max,$p->numpoints);
-			}
-		    }
-		}
-		$min=0;
-		if( $this->y2axis != null ) {
-		    foreach( $this->y2plots as $p ) {
-			$max=max($max,$p->numpoints-1);
-		    }		    
-		}
-		$n = count($this->ynaxis);
-		for( $i=0; $i < $n; ++$i ) {
-		    if( $this->ynaxis[$i] != null) {
-			foreach( $this->ynplots[$i] as $p ) {
-			    $max=max($max,$p->numpoints-1);
-			}		    
-		    }
-		}
-		
-		$this->xscale->Update($this->img,$min,$max);
-		$this->xscale->ticks->Set($this->xaxis->tick_step,1);
-		$this->xscale->ticks->SupressMinorTickMarks();
-	    }
-	    else {
-		list($min,$max) = $this->GetXMinMax();
-
-		$lres = $this->GetLinesXMinMax($this->lines);
-		if( $lres ) {
-		    list($linmin,$linmax) = $lres ;
-		    $min = min($min,$linmin);
-		    $max = max($max,$linmax);
-		}
-
-		$lres = $this->GetLinesXMinMax($this->y2lines);
-		if( $lres ) {
-		    list($linmin,$linmax) = $lres ;
-		    $min = min($min,$linmin);
-		    $max = max($max,$linmax);
-		}
-
-		$tres = $this->GetTextsXMinMax();
-		if( $tres ) {
-		    list($tmin,$tmax) = $tres ;
-		    $min = min($min,$tmin);
-		    $max = max($max,$tmax);
-		}
-
-		$tres = $this->GetTextsXMinMax(true);
-		if( $tres ) {
-		    list($tmin,$tmax) = $tres ;
-		    $min = min($min,$tmin);
-		    $max = max($max,$tmax);
-		}
-
-		$this->xscale->AutoScale($this->img,$min,$max,round($this->img->plotwidth/$this->xtick_factor));
-	    }
-			
-	    //Adjust position of y-axis and y2-axis to minimum/maximum of x-scale
-	    if( !is_numeric($this->yaxis->pos) && !is_string($this->yaxis->pos) )
-	    	$this->yaxis->SetPos($this->xscale->GetMinVal());
-	    if( $this->y2axis != null ) {
-		if( !is_numeric($this->y2axis->pos) && !is_string($this->y2axis->pos) )
-		    $this->y2axis->SetPos($this->xscale->GetMaxVal());
-		$this->y2axis->SetTitleSide(SIDE_RIGHT);
-	    }
-	    $n = count($this->ynaxis);
-	    $nY2adj = $this->y2axis != null ? $this->iYAxisDeltaPos : 0;
-	    for( $i=0; $i < $n; ++$i ) { 
-		if( $this->ynaxis[$i] != null ) {
-		    if( !is_numeric($this->ynaxis[$i]->pos) && !is_string($this->ynaxis[$i]->pos) ) {
-			$this->ynaxis[$i]->SetPos($this->xscale->GetMaxVal());
-		  $this->ynaxis[$i]->SetPosAbsDelta($i*$this->iYAxisDeltaPos + $nY2adj);
-		    }
-		    $this->ynaxis[$i]->SetTitleSide(SIDE_RIGHT);
-		}
-	    }
-
-	}	
-	elseif( $this->xscale->IsSpecified() &&  
-		( $this->xscale->auto_ticks || !$this->xscale->ticks->IsSpecified()) ) {
-	    // The tick calculation will use the user suplied min/max values to determine
-	    // the ticks. If auto_ticks is false the exact user specifed min and max
-	    // values will be used for the scale. 
-	    // If auto_ticks is true then the scale might be slightly adjusted
-	    // so that the min and max values falls on an even major step.
-	    $min = $this->xscale->scale[0];
-	    $max = $this->xscale->scale[1];
-	    $this->xscale->AutoScale($this->img,$min,$max,
-				     round($this->img->plotwidth/$this->xtick_factor),
-				     false);
-
-	    // Now make sure we show enough precision to accurate display the
-	    // labels. If this is not done then the user might end up with
-	    // a scale that might actually start with, say 13.5, butdue to rounding
-	    // the scale label will ony show 14.
-	    if( abs(floor($min)-$min) > 0 ) {
-		
-		// If the user has set a format then we bail out
-		if( $this->xscale->ticks->label_formatstr == '' && $this->xscale->ticks->label_dateformatstr == '' ) {
-		    $this->xscale->ticks->precision = abs( floor(log10( abs(floor($min)-$min))) )+1;
-		}
-	    }
-
-
-	    if( $this->y2axis != null ) {
-		if( !is_numeric($this->y2axis->pos) && !is_string($this->y2axis->pos) )
-		    $this->y2axis->SetPos($this->xscale->GetMaxVal());
-		$this->y2axis->SetTitleSide(SIDE_RIGHT);
-	    }
-
-	}
-		
-	// If we have a negative values and x-axis position is at 0
-	// we need to supress the first and possible the last tick since
-	// they will be drawn on top of the y-axis (and possible y2 axis)
-	// The test below might seem strange the reasone being that if
-	// the user hasn't specified a value for position this will not
-	// be set until we do the stroke for the axis so as of now it
-	// is undefined.
-	// For X-text scale we ignore all this since the tick are usually
-	// much further in and not close to the Y-axis. Hence the test 
-	// for 'text'	
-
-	if( ($this->yaxis->pos==$this->xscale->GetMinVal() || 
-	     (is_string($this->yaxis->pos) && $this->yaxis->pos=='min')) &&  
-	    !is_numeric($this->xaxis->pos) && $this->yscale->GetMinVal() < 0 && 
-	    substr($this->axtype,0,4) != 'text' && $this->xaxis->pos!="min" ) {
-
-	    //$this->yscale->ticks->SupressZeroLabel(false);
-	    $this->xscale->ticks->SupressFirst();
-	    if( $this->y2axis != null ) {
-		$this->xscale->ticks->SupressLast();
-	    }
-	}
-	elseif( !is_numeric($this->yaxis->pos) && $this->yaxis->pos=='max' ) {
-	    $this->xscale->ticks->SupressLast();
-	}
-	
-
-	if( !$_csim ) {
-	    $this->StrokePlotArea();
-	    if( $this->iIconDepth == DEPTH_BACK ) {
-		$this->StrokeIcons();
-	    }
-	}
-	$this->StrokeAxis(false);
-
-	// Stroke bands
-	if( $this->bands != null && !$_csim) 
-	    for($i=0; $i < count($this->bands); ++$i) {
-		// Stroke all bands that asks to be in the background
-		if( $this->bands[$i]->depth == DEPTH_BACK )
-		    $this->bands[$i]->Stroke($this->img,$this->xscale,$this->yscale);
-	    }
-
-	if( $this->y2bands != null && $this->y2scale != null && !$_csim )
-	    for($i=0; $i < count($this->y2bands); ++$i) {
-		// Stroke all bands that asks to be in the foreground
-		if( $this->y2bands[$i]->depth == DEPTH_BACK )
-		    $this->y2bands[$i]->Stroke($this->img,$this->xscale,$this->y2scale);
-	    }
-
-
-	if( $this->grid_depth == DEPTH_BACK && !$_csim) {
-	    $this->ygrid->Stroke();
-	    $this->xgrid->Stroke();
-	}
-				
-	// Stroke Y2-axis
-	if( $this->y2axis != null && !$_csim) {		
-	    $this->y2axis->Stroke($this->xscale); 				
-	    $this->y2grid->Stroke();
-	}
-
-	// Stroke yn-axis
-	$n = count($this->ynaxis); 
-	for( $i=0; $i < $n; ++$i ) {
-	    $this->ynaxis[$i]->Stroke($this->xscale); 				
-	}
-
-	$oldoff=$this->xscale->off;
-	if(substr($this->axtype,0,4)=="text") {
-	    if( $this->text_scale_abscenteroff > -1 ) {
-		// For a text scale the scale factor is the number of pixel per step. 
-		// Hence we can use the scale factor as a substitute for number of pixels
-		// per major scale step and use that in order to adjust the offset so that
-		// an object of width "abscenteroff" becomes centered.
-		$this->xscale->off += round($this->xscale->scale_factor/2)-round($this->text_scale_abscenteroff/2);
-	    }
-	    else {
-		$this->xscale->off += 
-		    ceil($this->xscale->scale_factor*$this->text_scale_off*$this->xscale->ticks->minor_step);
-	    }
-	}
-
-	if( $this->iDoClipping ) {
-	    $oldimage = $this->img->CloneCanvasH();
-	}
-
-	if( ! $this->y2orderback ) {
-	    // Stroke all plots for Y1 axis
-	    for($i=0; $i < count($this->plots); ++$i) {
-		$this->plots[$i]->Stroke($this->img,$this->xscale,$this->yscale);
-		$this->plots[$i]->StrokeMargin($this->img);
-	    }						
-	}
-
-	// Stroke all plots for Y2 axis
-	if( $this->y2scale != null )
-	    for($i=0; $i< count($this->y2plots); ++$i ) {	
-		$this->y2plots[$i]->Stroke($this->img,$this->xscale,$this->y2scale);
-	    }		
-
-	if( $this->y2orderback ) {
-	    // Stroke all plots for Y1 axis
-	    for($i=0; $i < count($this->plots); ++$i) {
-		$this->plots[$i]->Stroke($this->img,$this->xscale,$this->yscale);
-		$this->plots[$i]->StrokeMargin($this->img);
-	    }						
-	}
-
-	$n = count($this->ynaxis); 
-	for( $i=0; $i < $n; ++$i ) {
-	    $m = count($this->ynplots[$i]);
-	    for( $j=0; $j < $m; ++$j ) { 
-		$this->ynplots[$i][$j]->Stroke($this->img,$this->xscale,$this->ynscale[$i]);
-		$this->ynplots[$i][$j]->StrokeMargin($this->img);
-	    }
-	}
-
-	if( $this->iIconDepth == DEPTH_FRONT) {
-	    $this->StrokeIcons();
-	}
-	
-	if( $this->iDoClipping ) {
-	    // Clipping only supports graphs at 0 and 90 degrees
-	    if( $this->img->a == 0 ) {
-		$this->img->CopyCanvasH($oldimage,$this->img->img,
-					$this->img->left_margin,$this->img->top_margin,
-					$this->img->left_margin,$this->img->top_margin,
-					$this->img->plotwidth+1,$this->img->plotheight);
-	    }
-	    elseif( $this->img->a == 90 ) {
-		$adj = ($this->img->height - $this->img->width)/2;
-		$this->img->CopyCanvasH($oldimage,$this->img->img,
-					$this->img->bottom_margin-$adj,$this->img->left_margin+$adj,
-					$this->img->bottom_margin-$adj,$this->img->left_margin+$adj,
-					$this->img->plotheight+1,$this->img->plotwidth);
-	    }
-	    else {
-		JpGraphError::RaiseL(25035,$this->img->a);//('You have enabled clipping. Cliping is only supported for graphs at 0 or 90 degrees rotation. Please adjust you current angle (='.$this->img->a.' degrees) or disable clipping.');
-	    }
-	    $this->img->Destroy();
-	    $this->img->SetCanvasH($oldimage);
-	}
-
-	$this->xscale->off=$oldoff;
-		
-	if( $this->grid_depth == DEPTH_FRONT && !$_csim ) {
-	    $this->ygrid->Stroke();
-	    $this->xgrid->Stroke();
-	}
-
-	// Stroke bands
-	if( $this->bands!= null )
-	    for($i=0; $i < count($this->bands); ++$i) {
-		// Stroke all bands that asks to be in the foreground
-		if( $this->bands[$i]->depth == DEPTH_FRONT )
-		    $this->bands[$i]->Stroke($this->img,$this->xscale,$this->yscale);
-	    }
-
-	if( $this->y2bands!= null && $this->y2scale != null )
-	    for($i=0; $i < count($this->y2bands); ++$i) {
-		// Stroke all bands that asks to be in the foreground
-		if( $this->y2bands[$i]->depth == DEPTH_FRONT )
-		    $this->y2bands[$i]->Stroke($this->img,$this->xscale,$this->y2scale);
-	    }
-
-
-	// Stroke any lines added
-	if( $this->lines != null ) {
-	    for($i=0; $i < count($this->lines); ++$i) {
-		$this->lines[$i]->Stroke($this->img,$this->xscale,$this->yscale);
-		$this->lines[$i]->DoLegend($this);
-	    }
-	}
-
-	if( $this->y2lines != null && $this->y2scale != null ) {
-	    for($i=0; $i < count($this->y2lines); ++$i) {
-		$this->y2lines[$i]->Stroke($this->img,$this->xscale,$this->y2scale);
-		$this->y2lines[$i]->DoLegend($this);
-	    }
-	}
-
-	// Finally draw the axis again since some plots may have nagged
-	// the axis in the edges.
-	if( !$_csim ) {
-	    $this->StrokeAxis();
-	}
-
-	if( $this->y2scale != null && !$_csim ) 
-	    $this->y2axis->Stroke($this->xscale,false); 	
-		
-	if( !$_csim ) {
-	    $this->StrokePlotBox();
-	}
-		
-	// The titles and legends never gets rotated so make sure
-	// that the angle is 0 before stroking them				
-	$aa = $this->img->SetAngle(0);
-	$this->StrokeTitles();
-	$this->footer->Stroke($this->img);
-	$this->legend->Stroke($this->img);		
-	$this->img->SetAngle($aa);	
-	$this->StrokeTexts();	
-	$this->StrokeTables();
-
-	if( !$_csim ) {
-
-	    $this->img->SetAngle($aa);	
-			
-	    // Draw an outline around the image map	
-	    if(_JPG_DEBUG) {
-		$this->DisplayClientSideaImageMapAreas();		
-	    }
-	    
-	    // Should we do any final image transformation
-	    if( $this->iImgTrans ) {
-		if( !class_exists('ImgTrans',false) ) {
-		    require_once('jpgraph_imgtrans.php');
-		    //JpGraphError::Raise('In order to use image transformation you must include the file jpgraph_imgtrans.php in your script.');
-		}
-	       
-		$tform = new ImgTrans($this->img->img);
-		$this->img->img = $tform->Skew3D($this->iImgTransHorizon,$this->iImgTransSkewDist,
-						 $this->iImgTransDirection,$this->iImgTransHighQ,
-						 $this->iImgTransMinSize,$this->iImgTransFillColor,
-						 $this->iImgTransBorder);
-	    }
-
-	    // If the filename is given as the special "__handle"
-	    // then the image handler is returned and the image is NOT
-	    // streamed back
-	    if( $aStrokeFileName == _IMG_HANDLER ) {
-		return $this->img->img;
-	    }
-	    else {
-		// Finally stream the generated picture					
-		$this->cache->PutAndStream($this->img,$this->cache_name,$this->inline,$aStrokeFileName);		
-	    }
-	}
+    function Stroke($aStrokeFileName='') {
+        // Fist make a sanity check that user has specified a scale
+        if( empty($this->yscale) ) {
+            JpGraphError::RaiseL(25031);//('You must specify what scale to use with a call to Graph::SetScale().');
+        }
+
+        // Start by adjusting the margin so that potential titles will fit.
+        $this->AdjustMarginsForTitles();
+
+        // Give the plot a chance to do any scale adjuments the individual plots
+        // wants to do. Right now this is only used by the contour plot to set scale
+        // limits
+        for($i=0; $i < count($this->plots) ; ++$i ) {
+            $this->plots[$i]->PreScaleSetup($this);
+        }
+
+        // Init scale constants that are used to calculate the transformation from
+        // world to pixel coordinates
+        $this->InitScaleConstants();
+
+        // If the filename is the predefined value = '_csim_special_'
+        // we assume that the call to stroke only needs to do enough
+        // to correctly generate the CSIM maps.
+        // We use this variable to skip things we don't strictly need
+        // to do to generate the image map to improve performance
+        // a best we can. Therefor you will see a lot of tests !$_csim in the
+        // code below.
+        $_csim = ($aStrokeFileName===_CSIM_SPECIALFILE);
+
+        // If we are called the second time (perhaps the user has called GetHTMLImageMap()
+        // himself then the legends have alsready been populated once in order to get the
+        // CSIM coordinats. Since we do not want the legends to be populated a second time
+        // we clear the legends
+        $this->legend->Clear();
+
+        // We need to know if we have stroked the plot in the
+        // GetCSIMareas. Otherwise the CSIM hasn't been generated
+        // and in the case of GetCSIM called before stroke to generate
+        // CSIM without storing an image to disk GetCSIM must call Stroke.
+        $this->iHasStroked = true;
+
+        // Setup pre-stroked adjustments and Legends
+        $this->doPrestrokeAdjustments();
+
+        if ($this->graph_theme) {
+            $this->graph_theme->PreStrokeApply($this);
+        }
+
+        // Bail out if any of the Y-axis not been specified and
+        // has no plots. (This means it is impossible to do autoscaling and
+        // no other scale was given so we can't possible draw anything). If you use manual
+        // scaling you also have to supply the tick steps as well.
+        if( (!$this->yscale->IsSpecified() && count($this->plots)==0) ||
+            ($this->y2scale!=null && !$this->y2scale->IsSpecified() && count($this->y2plots)==0) ) {
+            //$e = "n=".count($this->y2plots)."\n";
+            // $e = "Can't draw unspecified Y-scale.<br>\nYou have either:<br>\n";
+            // $e .= "1. Specified an Y axis for autoscaling but have not supplied any plots<br>\n";
+            // $e .= "2. Specified a scale manually but have forgot to specify the tick steps";
+            JpGraphError::RaiseL(25026);
+        }
+
+        // Bail out if no plots and no specified X-scale
+        if( (!$this->xscale->IsSpecified() && count($this->plots)==0 && count($this->y2plots)==0) ) {
+            JpGraphError::RaiseL(25034);//("<strong>JpGraph: Can't draw unspecified X-scale.</strong><br>No plots.<br>");
+        }
+
+        // Autoscale the normal Y-axis
+        $this->doAutoScaleYAxis();
+
+        // Autoscale all additiopnal y-axis
+        $this->doAutoScaleYnAxis();
+
+        // Autoscale the regular x-axis and position the y-axis properly
+        $this->doAutoScaleXAxis();
+
+        // If we have a negative values and x-axis position is at 0
+        // we need to supress the first and possible the last tick since
+        // they will be drawn on top of the y-axis (and possible y2 axis)
+        // The test below might seem strange the reasone being that if
+        // the user hasn't specified a value for position this will not
+        // be set until we do the stroke for the axis so as of now it
+        // is undefined.
+        // For X-text scale we ignore all this since the tick are usually
+        // much further in and not close to the Y-axis. Hence the test
+        // for 'text'
+        if( ($this->yaxis->pos==$this->xscale->GetMinVal() || (is_string($this->yaxis->pos) && $this->yaxis->pos=='min')) &&
+            !is_numeric($this->xaxis->pos) && $this->yscale->GetMinVal() < 0 &&
+            substr($this->axtype,0,4) != 'text' && $this->xaxis->pos != 'min' ) {
+
+            //$this->yscale->ticks->SupressZeroLabel(false);
+            $this->xscale->ticks->SupressFirst();
+            if( $this->y2axis != null ) {
+                $this->xscale->ticks->SupressLast();
+            }
+        }
+        elseif( !is_numeric($this->yaxis->pos) && $this->yaxis->pos=='max' ) {
+            $this->xscale->ticks->SupressLast();
+        }
+
+        if( !$_csim ) {
+            $this->StrokePlotArea();
+            if( $this->iIconDepth == DEPTH_BACK ) {
+                $this->StrokeIcons();
+            }
+        }
+        $this->StrokeAxis(false);
+
+        // Stroke colored bands
+        $this->StrokeBands(DEPTH_BACK,$_csim);
+
+        if( $this->grid_depth == DEPTH_BACK && !$_csim) {
+            $this->ygrid->Stroke();
+            $this->xgrid->Stroke();
+        }
+
+        // Stroke Y2-axis
+        if( $this->y2axis != null && !$_csim) {
+            $this->y2axis->Stroke($this->xscale);
+            $this->y2grid->Stroke();
+        }
+
+        // Stroke yn-axis
+        $n = count($this->ynaxis);
+        for( $i=0; $i < $n; ++$i ) {
+            $this->ynaxis[$i]->Stroke($this->xscale);
+        }
+
+        $oldoff=$this->xscale->off;
+        if( substr($this->axtype,0,4) == 'text' ) {
+            if( $this->text_scale_abscenteroff > -1 ) {
+                // For a text scale the scale factor is the number of pixel per step.
+                // Hence we can use the scale factor as a substitute for number of pixels
+                // per major scale step and use that in order to adjust the offset so that
+                // an object of width "abscenteroff" becomes centered.
+                $this->xscale->off += round($this->xscale->scale_factor/2)-round($this->text_scale_abscenteroff/2);
+            }
+            else {
+                $this->xscale->off += ceil($this->xscale->scale_factor*$this->text_scale_off*$this->xscale->ticks->minor_step);
+            }
+        }
+
+        if( $this->iDoClipping ) {
+            $oldimage = $this->img->CloneCanvasH();
+        }
+
+        if( ! $this->y2orderback ) {
+            // Stroke all plots for Y1 axis
+            for($i=0; $i < count($this->plots); ++$i) {
+                $this->plots[$i]->Stroke($this->img,$this->xscale,$this->yscale);
+                $this->plots[$i]->StrokeMargin($this->img);
+            }
+        }
+
+        // Stroke all plots for Y2 axis
+        if( $this->y2scale != null ) {
+            for($i=0; $i< count($this->y2plots); ++$i ) {
+                $this->y2plots[$i]->Stroke($this->img,$this->xscale,$this->y2scale);
+            }
+        }
+
+        if( $this->y2orderback ) {
+            // Stroke all plots for Y1 axis
+            for($i=0; $i < count($this->plots); ++$i) {
+                $this->plots[$i]->Stroke($this->img,$this->xscale,$this->yscale);
+                $this->plots[$i]->StrokeMargin($this->img);
+            }
+        }
+
+        $n = count($this->ynaxis);
+        for( $i=0; $i < $n; ++$i ) {
+            $m = count($this->ynplots[$i]);
+            for( $j=0; $j < $m; ++$j ) {
+                $this->ynplots[$i][$j]->Stroke($this->img,$this->xscale,$this->ynscale[$i]);
+                $this->ynplots[$i][$j]->StrokeMargin($this->img);
+            }
+        }
+
+        if( $this->iIconDepth == DEPTH_FRONT) {
+            $this->StrokeIcons();
+        }
+
+        if( $this->iDoClipping ) {
+            // Clipping only supports graphs at 0 and 90 degrees
+            if( $this->img->a == 0 ) {
+                $this->img->CopyCanvasH($oldimage,$this->img->img,
+                $this->img->left_margin,$this->img->top_margin,
+                $this->img->left_margin,$this->img->top_margin,
+                $this->img->plotwidth+1,$this->img->plotheight);
+            }
+            elseif( $this->img->a == 90 ) {
+                $adj = ($this->img->height - $this->img->width)/2;
+                $this->img->CopyCanvasH($oldimage,$this->img->img,
+                $this->img->bottom_margin-$adj,$this->img->left_margin+$adj,
+                $this->img->bottom_margin-$adj,$this->img->left_margin+$adj,
+                $this->img->plotheight+1,$this->img->plotwidth);
+            }
+            else {
+                JpGraphError::RaiseL(25035,$this->img->a);//('You have enabled clipping. Cliping is only supported for graphs at 0 or 90 degrees rotation. Please adjust you current angle (='.$this->img->a.' degrees) or disable clipping.');
+            }
+            $this->img->Destroy();
+            $this->img->SetCanvasH($oldimage);
+        }
+
+        $this->xscale->off=$oldoff;
+
+        if( $this->grid_depth == DEPTH_FRONT && !$_csim ) {
+            $this->ygrid->Stroke();
+            $this->xgrid->Stroke();
+        }
+
+        // Stroke colored bands
+        $this->StrokeBands(DEPTH_FRONT,$_csim);
+
+        // Finally draw the axis again since some plots may have nagged
+        // the axis in the edges.
+        if( !$_csim ) {
+            $this->StrokeAxis();
+        }
+
+        if( $this->y2scale != null && !$_csim ) {
+            $this->y2axis->Stroke($this->xscale,false);
+        }
+
+        if( !$_csim ) {
+            $this->StrokePlotBox();
+        }
+
+        // The titles and legends never gets rotated so make sure
+        // that the angle is 0 before stroking them
+        $aa = $this->img->SetAngle(0);
+        $this->StrokeTitles();
+        $this->footer->Stroke($this->img);
+        $this->legend->Stroke($this->img);
+        $this->img->SetAngle($aa);
+        $this->StrokeTexts();
+        $this->StrokeTables();
+
+        if( !$_csim ) {
+
+            $this->img->SetAngle($aa);
+
+            // Draw an outline around the image map
+            if(_JPG_DEBUG) {
+                $this->DisplayClientSideaImageMapAreas();
+            }
+
+            // Should we do any final image transformation
+            if( $this->iImgTrans ) {
+                if( !class_exists('ImgTrans',false) ) {
+                    require_once('jpgraph_imgtrans.php');
+                    //JpGraphError::Raise('In order to use image transformation you must include the file jpgraph_imgtrans.php in your script.');
+                }
+
+                $tform = new ImgTrans($this->img->img);
+                $this->img->img = $tform->Skew3D($this->iImgTransHorizon,$this->iImgTransSkewDist,
+                $this->iImgTransDirection,$this->iImgTransHighQ,
+                $this->iImgTransMinSize,$this->iImgTransFillColor,
+                $this->iImgTransBorder);
+            }
+
+            // If the filename is given as the special "__handle"
+            // then the image handler is returned and the image is NOT
+            // streamed back
+            if( $aStrokeFileName == _IMG_HANDLER ) {
+                return $this->img->img;
+            }
+            else {
+                // Finally stream the generated picture
+                $this->cache->PutAndStream($this->img,$this->cache_name,$this->inline,$aStrokeFileName);
+            }
+        }
     }
 
     function SetAxisLabelBackground($aType,$aXFColor='lightgray',$aXColor='black',$aYFColor='lightgray',$aYColor='black') {
-	$this->iAxisLblBgType = $aType;
-	$this->iXAxisLblBgFillColor = $aXFColor;
-	$this->iXAxisLblBgColor = $aXColor;
-	$this->iYAxisLblBgFillColor = $aYFColor;
-	$this->iYAxisLblBgColor = $aYColor;
-    }
-
-//---------------
-// PRIVATE METHODS	
+        $this->iAxisLblBgType = $aType;
+        $this->iXAxisLblBgFillColor = $aXFColor;
+        $this->iXAxisLblBgColor = $aXColor;
+        $this->iYAxisLblBgFillColor = $aYFColor;
+        $this->iYAxisLblBgColor = $aYColor;
+    }
 
     function StrokeAxisLabelBackground() {
-	// Types 
-	// 0 = No background
-	// 1 = Only X-labels, length of axis
-	// 2 = Only Y-labels, length of axis
-	// 3 = As 1 but extends to width of graph
-	// 4 = As 2 but extends to height of graph
-	// 5 = Combination of 3 & 4
-	// 6 = Combination of 1 & 2
- 
-	$t = $this->iAxisLblBgType ;
-	if( $t < 1 ) return;
-	// Stroke optional X-axis label background color
-	if( $t == 1 || $t == 3 || $t == 5 || $t == 6 ) {
-	    $this->img->PushColor($this->iXAxisLblBgFillColor);
-	    if( $t == 1 || $t == 6 ) {
-		$xl = $this->img->left_margin;
-		$yu = $this->img->height - $this->img->bottom_margin + 1;
-		$xr = $this->img->width - $this->img->right_margin ;
-		$yl = $this->img->height-1-$this->frame_weight;
-	    }
-	    else { // t==3 || t==5
-		$xl = $this->frame_weight;
-		$yu = $this->img->height - $this->img->bottom_margin + 1;
-		$xr = $this->img->width - 1 - $this->frame_weight;
-		$yl = $this->img->height-1-$this->frame_weight;
-	    }
-
-	    $this->img->FilledRectangle($xl,$yu,$xr,$yl);
-	    $this->img->PopColor();
-
-	    // Check if we should add the vertical lines at left and right edge
-	    if( $this->iXAxisLblBgColor !== '' ) {
-		// Hardcode to one pixel wide
-		$this->img->SetLineWeight(1); 
-		$this->img->PushColor($this->iXAxisLblBgColor);
-		if( $t == 1 || $t == 6 ) {
-		    $this->img->Line($xl,$yu,$xl,$yl);
-		    $this->img->Line($xr,$yu,$xr,$yl);
-		}
-		else {
-		    $xl = $this->img->width - $this->img->right_margin ;
-		    $this->img->Line($xl,$yu-1,$xr,$yu-1);
-		}
-		$this->img->PopColor();
-	    }
-	}
-
-	if( $t == 2 || $t == 4 || $t == 5 || $t == 6 ) {
-	    $this->img->PushColor($this->iYAxisLblBgFillColor);
-	    if( $t == 2 || $t == 6 ) {	    
-		$xl = $this->frame_weight;
-		$yu = $this->frame_weight+$this->img->top_margin;
-		$xr = $this->img->left_margin - 1;
-		$yl = $this->img->height - $this->img->bottom_margin + 1;
-	    }
-	    else {
-		$xl = $this->frame_weight;
-		$yu = $this->frame_weight;
-		$xr = $this->img->left_margin - 1;
-		$yl = $this->img->height-1-$this->frame_weight;
-	    }
-
-	    $this->img->FilledRectangle($xl,$yu,$xr,$yl);
-	    $this->img->PopColor();
-
-	    // Check if we should add the vertical lines at left and right edge
-	    if( $this->iXAxisLblBgColor !== '' ) {
-		$this->img->PushColor($this->iXAxisLblBgColor);
-		if( $t == 2 || $t == 6 ) {
-		    $this->img->Line($xl,$yu-1,$xr,$yu-1);
-		    $this->img->Line($xl,$yl-1,$xr,$yl-1);		    
-		}
-		else {
-		    $this->img->Line($xr+1,$yu,$xr+1,$this->img->top_margin);		    
-		}
-		$this->img->PopColor();
-	    }
-
-	}
+        // Types
+        // 0 = No background
+        // 1 = Only X-labels, length of axis
+        // 2 = Only Y-labels, length of axis
+        // 3 = As 1 but extends to width of graph
+        // 4 = As 2 but extends to height of graph
+        // 5 = Combination of 3 & 4
+        // 6 = Combination of 1 & 2
+
+        $t = $this->iAxisLblBgType ;
+        if( $t < 1 ) return;
+
+        // Stroke optional X-axis label background color
+        if( $t == 1 || $t == 3 || $t == 5 || $t == 6 ) {
+            $this->img->PushColor($this->iXAxisLblBgFillColor);
+            if( $t == 1 || $t == 6 ) {
+                $xl = $this->img->left_margin;
+                $yu = $this->img->height - $this->img->bottom_margin + 1;
+                $xr = $this->img->width - $this->img->right_margin ;
+                $yl = $this->img->height-1-$this->frame_weight;
+            }
+            else { // t==3 || t==5
+                $xl = $this->frame_weight;
+                $yu = $this->img->height - $this->img->bottom_margin + 1;
+                $xr = $this->img->width - 1 - $this->frame_weight;
+                $yl = $this->img->height-1-$this->frame_weight;
+            }
+
+            $this->img->FilledRectangle($xl,$yu,$xr,$yl);
+            $this->img->PopColor();
+
+            // Check if we should add the vertical lines at left and right edge
+            if( $this->iXAxisLblBgColor !== '' ) {
+                // Hardcode to one pixel wide
+                $this->img->SetLineWeight(1);
+                $this->img->PushColor($this->iXAxisLblBgColor);
+                if( $t == 1 || $t == 6 ) {
+                    $this->img->Line($xl,$yu,$xl,$yl);
+                    $this->img->Line($xr,$yu,$xr,$yl);
+                }
+                else {
+                    $xl = $this->img->width - $this->img->right_margin ;
+                    $this->img->Line($xl,$yu-1,$xr,$yu-1);
+                }
+                $this->img->PopColor();
+            }
+        }
+
+        if( $t == 2 || $t == 4 || $t == 5 || $t == 6 ) {
+            $this->img->PushColor($this->iYAxisLblBgFillColor);
+            if( $t == 2 || $t == 6 ) {
+                $xl = $this->frame_weight;
+                $yu = $this->frame_weight+$this->img->top_margin;
+                $xr = $this->img->left_margin - 1;
+                $yl = $this->img->height - $this->img->bottom_margin + 1;
+            }
+            else {
+                $xl = $this->frame_weight;
+                $yu = $this->frame_weight;
+                $xr = $this->img->left_margin - 1;
+                $yl = $this->img->height-1-$this->frame_weight;
+            }
+
+            $this->img->FilledRectangle($xl,$yu,$xr,$yl);
+            $this->img->PopColor();
+
+            // Check if we should add the vertical lines at left and right edge
+            if( $this->iXAxisLblBgColor !== '' ) {
+                $this->img->PushColor($this->iXAxisLblBgColor);
+                if( $t == 2 || $t == 6 ) {
+                    $this->img->Line($xl,$yu-1,$xr,$yu-1);
+                    $this->img->Line($xl,$yl-1,$xr,$yl-1);
+                }
+                else {
+                    $this->img->Line($xr+1,$yu,$xr+1,$this->img->top_margin);
+                }
+                $this->img->PopColor();
+            }
+
+        }
     }
 
     function StrokeAxis($aStrokeLabels=true) {
-	
-	if( $aStrokeLabels ) {
-	    $this->StrokeAxisLabelBackground();
-	}
-
-	// Stroke axis
-	if( $this->iAxisStyle != AXSTYLE_SIMPLE ) {
-	    switch( $this->iAxisStyle ) {
-	        case AXSTYLE_BOXIN :
-	            $toppos = SIDE_DOWN;
-		    $bottompos = SIDE_UP;
-	            $leftpos = SIDE_RIGHT;
-	            $rightpos = SIDE_LEFT;
-	            break;
-		case AXSTYLE_BOXOUT :
-		    $toppos = SIDE_UP;
-	            $bottompos = SIDE_DOWN;	    
-	            $leftpos = SIDE_LEFT;
-		    $rightpos = SIDE_RIGHT;
-	            break;
-		case AXSTYLE_YBOXIN:
-	            $toppos = FALSE; 
-		    $bottompos = SIDE_UP;
-	            $leftpos = SIDE_RIGHT;
-	            $rightpos = SIDE_LEFT;
-		    break;
-		case AXSTYLE_YBOXOUT:
-		    $toppos = FALSE;
-	            $bottompos = SIDE_DOWN;	    
-	            $leftpos = SIDE_LEFT;
-		    $rightpos = SIDE_RIGHT;
-		    break;
-		default:
-	            JpGRaphError::RaiseL(25036,$this->iAxisStyle); //('Unknown AxisStyle() : '.$this->iAxisStyle);
-	            break;
-	    }
-	    
-	    // By default we hide the first label so it doesn't cross the
-	    // Y-axis in case the positon hasn't been set by the user.
-	    // However, if we use a box we always want the first value
-	    // displayed so we make sure it will be displayed.
-	    $this->xscale->ticks->SupressFirst(false);    
-
-	    // Now draw the bottom X-axis
-	    $this->xaxis->SetPos('min');
-	    $this->xaxis->SetLabelSide(SIDE_DOWN);
-	    $this->xaxis->scale->ticks->SetSide($bottompos);
-	    $this->xaxis->Stroke($this->yscale,$aStrokeLabels);
-
-	    if( $toppos !== FALSE ) {
-		// We also want a top X-axis
-		$this->xaxis = $this->xaxis;
-		$this->xaxis->SetPos('max');
-		$this->xaxis->SetLabelSide(SIDE_UP);
-		// No title for the top X-axis 
-		if( $aStrokeLabels ) {
-		    $this->xaxis->title->Set('');
-		}
-		$this->xaxis->scale->ticks->SetSide($toppos);
-		$this->xaxis->Stroke($this->yscale,$aStrokeLabels);
-	    }
-
-	    // Stroke the left Y-axis
-	    $this->yaxis->SetPos('min');
-	    $this->yaxis->SetLabelSide(SIDE_LEFT);
-	    $this->yaxis->scale->ticks->SetSide($leftpos);
-	    $this->yaxis->Stroke($this->xscale,$aStrokeLabels);
-
-	    // Stroke the  right Y-axis
-	    $this->yaxis->SetPos('max');
-	    // No title for the right side 
-	    if( $aStrokeLabels ) {
-		$this->yaxis->title->Set('');
-	    }
-	    $this->yaxis->SetLabelSide(SIDE_RIGHT);
-	    $this->yaxis->scale->ticks->SetSide($rightpos);
-	    $this->yaxis->Stroke($this->xscale,$aStrokeLabels);  
-	}
-	else {
-	    $this->xaxis->Stroke($this->yscale,$aStrokeLabels);
-	    $this->yaxis->Stroke($this->xscale,$aStrokeLabels);		
-	}
+
+        if( $aStrokeLabels ) {
+            $this->StrokeAxisLabelBackground();
+        }
+
+        // Stroke axis
+        if( $this->iAxisStyle != AXSTYLE_SIMPLE ) {
+            switch( $this->iAxisStyle ) {
+                case AXSTYLE_BOXIN :
+                    $toppos = SIDE_DOWN;
+                    $bottompos = SIDE_UP;
+                    $leftpos = SIDE_RIGHT;
+                    $rightpos = SIDE_LEFT;
+                    break;
+                case AXSTYLE_BOXOUT :
+                    $toppos = SIDE_UP;
+                    $bottompos = SIDE_DOWN;
+                    $leftpos = SIDE_LEFT;
+                    $rightpos = SIDE_RIGHT;
+                    break;
+                case AXSTYLE_YBOXIN:
+                    $toppos = FALSE;
+                    $bottompos = SIDE_UP;
+                    $leftpos = SIDE_RIGHT;
+                    $rightpos = SIDE_LEFT;
+                    break;
+                case AXSTYLE_YBOXOUT:
+                    $toppos = FALSE;
+                    $bottompos = SIDE_DOWN;
+                    $leftpos = SIDE_LEFT;
+                    $rightpos = SIDE_RIGHT;
+                    break;
+                default:
+                    JpGRaphError::RaiseL(25036,$this->iAxisStyle); //('Unknown AxisStyle() : '.$this->iAxisStyle);
+                    break;
+            }
+
+            // By default we hide the first label so it doesn't cross the
+            // Y-axis in case the positon hasn't been set by the user.
+            // However, if we use a box we always want the first value
+            // displayed so we make sure it will be displayed.
+            $this->xscale->ticks->SupressFirst(false);
+
+            // Now draw the bottom X-axis
+            $this->xaxis->SetPos('min');
+            $this->xaxis->SetLabelSide(SIDE_DOWN);
+            $this->xaxis->scale->ticks->SetSide($bottompos);
+            $this->xaxis->Stroke($this->yscale,$aStrokeLabels);
+
+            if( $toppos !== FALSE ) {
+                // We also want a top X-axis
+                $this->xaxis = $this->xaxis;
+                $this->xaxis->SetPos('max');
+                $this->xaxis->SetLabelSide(SIDE_UP);
+                // No title for the top X-axis
+                if( $aStrokeLabels ) {
+                    $this->xaxis->title->Set('');
+                }
+                $this->xaxis->scale->ticks->SetSide($toppos);
+                $this->xaxis->Stroke($this->yscale,$aStrokeLabels);
+            }
+
+            // Stroke the left Y-axis
+            $this->yaxis->SetPos('min');
+            $this->yaxis->SetLabelSide(SIDE_LEFT);
+            $this->yaxis->scale->ticks->SetSide($leftpos);
+            $this->yaxis->Stroke($this->xscale,$aStrokeLabels);
+
+            // Stroke the  right Y-axis
+            $this->yaxis->SetPos('max');
+            // No title for the right side
+            if( $aStrokeLabels ) {
+                $this->yaxis->title->Set('');
+            }
+            $this->yaxis->SetLabelSide(SIDE_RIGHT);
+            $this->yaxis->scale->ticks->SetSide($rightpos);
+            $this->yaxis->Stroke($this->xscale,$aStrokeLabels);
+        }
+        else {
+            $this->xaxis->Stroke($this->yscale,$aStrokeLabels);
+            $this->yaxis->Stroke($this->xscale,$aStrokeLabels);
+        }
     }
 
